%define		plugin		data
%define		php_min_version 5.0.0
%include	/usr/lib/rpm/macros.php
Summary:	DokuWiki Structured Data Plugin
Name:		dokuwiki-plugin-%{plugin}
Version:	20120716
Release:	4
License:	GPL v2
Group:		Applications/WWW
#Source0:	http://github.com/splitbrain/dokuwiki-plugin-%{plugin}/tarball/master#/%{plugin}-%{version}.tgz
Source0:	https://github.com/Klap-in/dokuwiki-plugin-data/tarball/pdo#/%{plugin}-pdo-%{version}.tgz
# Source0-md5:	49cfa6206cdf138593905d3622cb1a4a
URL:		http://wiki.splitbrain.org/plugin:data
Patch2:		separator-style.patch
Patch3:		separate-rpmdb.patch
BuildRequires:	rpm-php-pearprov
BuildRequires:	rpmbuild(macros) >= 1.520
Requires:	php(core) >= %{php_min_version}
Requires(triggerun):	sqlite
Requires:	dokuwiki >= 20090214b-5
Requires:	dokuwiki-plugin-sqlite >= 20120619
Requires:	php(pcre)
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		dokuconf	/etc/webapps/dokuwiki
%define		dokudir		/usr/share/dokuwiki
%define		metadir		/var/lib/dokuwiki/meta
%define		plugindir	%{dokudir}/lib/plugins/%{plugin}
%define		find_lang 	%{_usrlibrpm}/dokuwiki-find-lang.sh %{buildroot}

# no pear deps
%define		_noautopear	pear

# sqlite is dokuwiki-plugin-sqlite dep, not ours
%define		_noautophp	php-sqlite

# put it together for rpmbuild
%define		_noautoreq	%{?_noautophp} %{?_noautopear}

%description
This plugin allows you to add structured data to any DokuWiki page.
Think about this data as additional named attributes. Those attributes
can then be queried and aggregated. The plugin is similar to what was
done here for the repository plugin but its internals are very
different to the repository plugin.

%prep
%setup -qc
mv *-%{plugin}-*/* .
%patch2 -p1
%patch3 -p1

version=$(awk '/date/{print $2}' plugin.info.txt)
if [ $(echo "$version" | tr -d -) != %{version} ]; then
	: %%{version} mismatch
#	exit 1
fi

# nothing to do with tests
rm -rf _test

# cleanup backups after patching
find '(' -name '*~' -o -name '*.orig' ')' -print0 | xargs -0 -r -l512 rm -f

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{plugindir},%{metadir}}
cp -a . $RPM_BUILD_ROOT%{plugindir}
%{__rm} $RPM_BUILD_ROOT%{plugindir}/README
touch $RPM_BUILD_ROOT%{metadir}/data.sqlite

# find locales
%find_lang %{name}.lang

%clean
rm -rf $RPM_BUILD_ROOT

%post
# force css cache refresh
if [ -f %{dokuconf}/local.php ]; then
	touch %{dokuconf}/local.php
fi

%triggerun -- %{name} < 20100322-0.5
# move to new location
mv /var/lib/dokuwiki/cache/dataplugin.sqlite %{metadir}/data.sqlite

# perform new indexes add manually
sqlite %{metadir}/data.sqlite <<'EOF'
CREATE TABLE opts (opt,val);
CREATE UNIQUE INDEX idx_opt ON opts(opt);
INSERT INTO opts VALUES ('dbversion', 1);
EOF
chown root:http %{metadir}/data.sqlite
chmod 660 %{metadir}/data.sqlite

%triggerun -- %{name} < 20120716-3
if [ -f %{metadir}/data.sqlite3 ]; then
	# already migrated
	exit 0
fi
# perform sqlite2 -> sqlite3 migration of both tools present
if [ ! -x /usr/bin/sqlite ] || [ ! -x /usr/bin/sqlite3 ]; then
	echo >&2 "data plugin: To migrate db from sqlite2 to sqlite3 you need to install 'sqlite' and 'sqlite3' packages"
	exit 0
fi

sqlite %{metadir}/data.sqlite .dump > %{metadir}/data.dump
sqlite3 %{metadir}/data.dump.new < %{metadir}/data.dump
mv %{metadir}/data.sqlite3{.new,}
chown root:http %{metadir}/data.sqlite3
chmod 660 %{metadir}/data.sqlite3

%files -f %{name}.lang
%defattr(644,root,root,755)
%doc README
%dir %{plugindir}
%{plugindir}/admin
%{plugindir}/syntax
%{plugindir}/conf
%{plugindir}/db
%{plugindir}/*.js
%{plugindir}/*.php
%{plugindir}/*.txt
%{plugindir}/*.css
%attr(660,http,http) %ghost %{metadir}/data.sqlite
%changelog
* Thu Aug 23 2012 Elan Ruusamäe <glen@delfi.ee> 272501f
- use php(core) as dependency to require php version
- release 3 (by relup.sh)

* Fri Aug 17 2012 Elan Ruusamäe <glen@delfi.ee> cf948c6
fixing upgrade trigger

* Thu Aug 16 2012 Elan Ruusamäe <glen@delfi.ee> ca42795
perform sqlite2->sqlite3 upgrade if packages present

* Thu Aug 16 2012 Elan Ruusamäe <glen@delfi.ee> 2a86300
up to 20120716

* Tue Aug 07 2012 Elan Ruusamäe <glen@delfi.ee> f4bb031
- use virtual php extension deps (to be independant of php version)
- release 5 (by relup.sh)

* Sun Jul 15 2012 Elan Ruusamäe <glen@delfi.ee> 58185fe
- switch to pdo branch

* Tue Jun 12 2012 Elan Ruusamäe <glen@pld-linux.org> 99a1361
- up to 20120404

* Tue Mar 13 2012 Elan Ruusamäe <glen@pld-linux.org> d3fe329
- up to 20120227; adds %lastmod% filter

* Mon Nov 07 2011 Elan Ruusamäe <glen@pld-linux.org> 1d83f60
- skip packaging tests

* Mon Nov 07 2011 Elan Ruusamäe <glen@pld-linux.org> 878b357
- up to decc347 (20110615)

* Wed Feb 02 2011 sparky <sparky@pld-linux.org> dca91af
- BR: rpm-php-pearprov

* Wed Dec 01 2010 Elan Ruusamäe <glen@pld-linux.org> 8650b3c
- drop _interwiki and _map patches, can be achieved with type aliases now

* Wed Dec 01 2010 Elan Ruusamäe <glen@pld-linux.org> ce3f39e
- add separate-rpmdb.patch

* Tue Nov 23 2010 Elan Ruusamäe <glen@pld-linux.org> cb5e42a
- rel 1

* Fri Nov 05 2010 Elan Ruusamäe <glen@pld-linux.org> 14319ec
- new snap fixes _img editing, issue #32

* Tue Nov 02 2010 Elan Ruusamäe <glen@pld-linux.org> 4f0d433
- php deps

* Tue Nov 02 2010 Elan Ruusamäe <glen@pld-linux.org> b0216a6
- up to 20100608

* Thu May 13 2010 sparky <sparky@pld-linux.org> 5caf09b
- BR: unzip

* Tue Mar 23 2010 Elan Ruusamäe <glen@pld-linux.org> 860b9ce
- up to 20100322 snap, requires sqlite plugin

* Thu Mar 18 2010 Elan Ruusamäe <glen@pld-linux.org> 58e46b8
- add <span class="sep"> to table lists as well

